/*
 * Copyright (c) 2015 Tricoire Sebastien 3dsman@free.fr
 *
 * This software is provided 'as-is', without any express or implied
 * warranty.  In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not
 * claim that you wrote the original software. If you use this software
 * in a product, an acknowledgment in the product documentation would be
 * appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 * misrepresented as being the original software.
 * 3. This notice may not be removed or altered from any source distribution.
 *
 */

#ifndef OE_BIRAILSTITCH_H
#define OE_BIRAILSTITCH_H

#include "curves/OE_curve.h"
#include "stitchs/OE_stitchs.h"

class OE_birailstitch : public OE_stitchs
{
	public:
		//OE_birailstitch();
		OE_birailstitch(OE_thread* thread,OE_curve* curve1,OE_curve* curve2, float len);
		OE_birailstitch(OE_thread* thread,OE_curve* curve1, OE_curve* curve2, bool reverse1, bool reverse2, float offset1, float offset2, float len);
		~OE_birailstitch();
		
		virtual bool check();
		
		virtual void refresh();
		
		
		void setCurve1( OE_curve* curve);
		void setReverse1(bool reverse);
		void setOffset1(float offset);
		void setCurve2( OE_curve* curve);
		void setReverse2(bool reverse);
		void setOffset2(float offset);
		void setLen(float len);
		
		static float defaultLen;
		
		void delDependency(OE_base * object);
		
	protected:
		OE_curve* curve1 = nullptr;
		OE_curve* curve2 = nullptr;
		bool reverse1 = false;
		float offset1 = 0;
		bool reverse2 = false;
		float offset2 = 0;
		float len = 0;
		

};

#endif // OE_BIRAILSTITCH_H
